QGIS Application - Bug report #21670
DB Manager - load sql query as layer with primary key
2019-03-25 02:34 PM - Patrice V

Status: Closed

Priority: High

Assignee:

Category: Python bindings / sipify

Affected QGIS version:3.7(master) Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: duplicate
Crashes QGIS or corrupls data: Copied to github as #: 29486
Description

Hi,

| use Win7 and Qgis 3.4 (or 3.6, the same bug appends)
| use DB manager for loading a layer in qgis.
If 1 do in the request dialog :
- "SELECT * FROM spatialite_table"
- or "SELECT * FROM spatialite_view"
It's ok.

Then | check "Load as a new layer", And | check "primary key column" with the column | want for the primary key.

It seems ok, the layer is loaded in qgis, and in properties/source there is
dbname="'path_to_spatialite_file' key="column_with_pk_i_want' table="spatialite_table" (geom) sql=

But When | do with pyqgis :

print([fet.id() for fet in the_qgis_layer.getFeatures()])

it's printing the first column value of the spatialite_table, and not the 'column_with_pk_i_want' column value...
It was working well in qgis 2.18.

Thanks in advance,
Regards,

Related issues:

Duplicates QGIS Application - Bug report # 21397: Assigning a primary key in ... Open 2019-02-26

History

#1 - 2019-03-25 02:57 PM - Alessandro Pasotti
- Duplicates Bug report #21397: Assigning a primary key in QgsDataSourceUri doesn't work added

#2 - 2019-03-26 11:33 AM - Patrice V

another note : it seems to be specific to spatialite db. | tried with a postgis db and behaviour is normal...

#3 - 2019-03-26 03:23 PM - Giovanni Manghi

- Category changed from DB Manager to Python bindings / sipify

#4 - 2019-03-26 03:23 PM - Giovanni Manghi

- Resolution set to duplicate
- Status changed from Open to Closed
